/* Author : Dario GENGA
 * Date : 16.11.2021
 * Description : Manipulate matrix
 */

#include <stdio.h>
#include <stdlib.h>
#include "matrix.h"

int main() {
    matrix mat, cloned, transposed, sub;
    int32_t m = 3;
    int32_t n = 4;
    int32_t s = m * n;
    int32_t val = 0;
    int32_t data[12] = { 2, 1, -1, -2, 3, 1, 1, 3, 1, 4, -1, -1 };
    // Init
    matrix_init(&mat, m, n, val);
    printf("Empty matrix %dx%d\n", m, n);
    matrix_print(mat);
    // Init from array
    matrix_init_from_array(&mat, m, n, data, s);
    printf("Matrix %dx%d from array\n", m, n);
    matrix_print(mat);
    // Clone
    matrix_clone(&cloned, mat);
    printf("Cloned matrix :\n");
    matrix_print(cloned);
    // Transpose
    matrix_transpose(&transposed, mat);
    printf("Transposed matrix :\n");
    matrix_print(transposed);
    // Sub matrix
    matrix_extract_submatrix(&sub, transposed, 1, 4, 1, 3);
    printf("Sub matrix :\n");
    matrix_print(sub);
    // Equal
    if (matrix_is_equal(mat, cloned)) {
        printf("The following matrix are equals :\n");
    } else {
        printf("The following matrix are not equals :\n");
    }
    printf("Matrix 1\n");
    matrix_print(mat);
    printf("Matrix 2\n");
    matrix_print(cloned);
    // Get & set
    int32_t element;
    matrix_get(&element, mat, 0, 0);
    printf("First element of the first matrix : %d\n", element);
    matrix_set(mat, 0, 0, 42);
    printf("The first element of the first matrix has been changed :\n");
    matrix_print(mat);

    // Free the memory
    matrix_destroy(&mat);
    matrix_destroy(&cloned);
    matrix_destroy(&transposed);
    matrix_destroy(&sub);

    
    return EXIT_SUCCESS;
}
