/* Author : Dario GENGA
 * Date : 16.11.2021
 * Description : Manipulate matrix
 */
#include "matrix.h"
#include <assert.h>
#include <stdbool.h>
#include <stdio.h>

int main() {
    // Initialisation
    matrix mat;
    matrix cloned;
    matrix transposed;
    matrix sub;
    int32_t m = 3;
    int32_t n = 4;
    int32_t val = 1;
    int32_t first_elem = 2;
    int32_t set_elem = 100;
    int32_t data[12] = { first_elem, 1, -1, -2, 3, 1, 1, 3, 1, 4, -1, -1 };
    int32_t elem;
    // Starting the tests...
    printf("Starting the tests...\n");
    assert(matrix_alloc(&mat, m, n) == ok);
    assert(matrix_destroy(&mat) == ok);
    assert(matrix_init(&mat, m, n, val) == ok);
    assert(matrix_destroy(&mat) == ok);
    assert(matrix_init(&mat, -1, n, val) == err);
    assert(matrix_destroy(&mat) == ok);
    assert(matrix_init_from_array(&mat, m, n, data, m*n) == ok);
    assert(matrix_clone(&cloned, mat) == ok);
    assert(matrix_transpose(&transposed, mat) == ok);
    assert(matrix_print(mat) == ok);
    assert(matrix_extract_submatrix(&sub, mat, 0, 2, 0, 2) == ok);
    assert(matrix_is_equal(mat, cloned) == true);
    assert(matrix_get(&elem, mat, 0, 0) == ok);
    assert(mat.data[0][0] == first_elem);
    assert(matrix_set(mat, 0, 0, set_elem) == ok);
    assert(mat.data[0][0] == set_elem);
    assert(matrix_destroy(&mat) == ok);
    matrix_destroy(&cloned);
    matrix_destroy(&transposed);
    matrix_destroy(&sub);


    printf("The tests are completed and were successful !\n");
    return EXIT_SUCCESS;
}
